module Spoll::Models
  class Base
    include Virtus.model(nullify_blank: true)

    attribute :id, Integer

    def set_relations(response)
    end

    def set_relation(relation, data, primary_key, foreign_key)
      record = find_by(data, primary_key, send(foreign_key))
      send("#{relation}=", record)
    end

    def set_array_relation(relation, data, primary_key, foreign_key)
      records = find_all(data, primary_key, send(foreign_key))
      send("#{relation}=", records)
    end

    private

    def find_by(json, key, value)
      json.each do |record|
        return record if record[key].eql?(value)
      end

      nil
    end

    def find_all(json, key, value)
      result = []

      json.each do |record|
        result << record if record[key].eql?(value)
      end

      result
    end

  end
end
